--[[
    Author: Alternator (Massiner of Nathrezim)
    Copyright 2010
	
	Notes: 

--]]

local CustomAction = BFCustomAction;
local Const = BFConst;
local Util = BFUtil;
local UILib = BFUILib;

function CustomAction.GetTexture(Action)
	if (Action == "configuremode") then
		return Const.ImagesDir.."Configure.tga";
	elseif (Action == "createbarmode") then
		return Const.ImagesDir.."CreateBar.tga";
	elseif (Action == "destroybarmode") then
		return Const.ImagesDir.."DestroyBar.tga";
	elseif (Action == "advancedtoolsmode") then
		return Const.ImagesDir.."AdvancedTools.tga";
	end
end

function CustomAction.SetAttributes(Action, Widget)
	if (Action == "configuremode") then
		Widget:SetAttribute("type", "macro");
		Widget:SetAttribute("macrotext", "/click BFToolbarToggle");
	elseif (Action == "createbarmode") then
		Widget:SetAttribute("type", "macro");
		Widget:SetAttribute("macrotext", "/click BFToolbarCreateBar");
	elseif (Action == "destroybarmode") then
		Widget:SetAttribute("type", "macro");
		Widget:SetAttribute("macrotext", "/click BFToolbarDestroyBar");
	elseif (Action == "advancedtoolsmode") then
		Widget:SetAttribute("type", "macro");
		Widget:SetAttribute("macrotext", "/click BFToolbarAdvanced");
	end
end

function CustomAction.GetChecked(Action)
	if (Action == 'configuremode') then
		if (BFConfigureLayer:IsShown()) then
			return 1;
		end
	elseif (Action == 'createbarmode') then
		if (BFCreateBarOverlay:IsShown()) then
			return 1;
		end
	elseif (Action == 'destroybarmode') then
		if (BFDestroyBarOverlay:IsShown()) then
			return 1;
		end
	elseif (Action == 'advancedtoolsmode') then
		if (BFAdvancedToolsLayer:IsShown() and BFConfigureLayer:IsShown()) then
			return 1;
		end
	end
	return nil;
end

function CustomAction.UpdateTooltip(Action)
	if (Action == 'configuremode') then
		GameTooltip:SetText(Util.GetLocaleString("ConfigureModeTooltip"), nil, nil, nil, nil, 1);
	elseif (Action == 'createbarmode') then
		GameTooltip:SetText(Util.GetLocaleString("CreateBarTooltip"), nil, nil, nil, nil, 1);
	elseif (Action == 'destroybarmode') then
		GameTooltip:SetText(Util.GetLocaleString("DestroyBarTooltip"), nil, nil, nil, nil, 1);
	elseif (Action == 'advancedtoolsmode') then
		GameTooltip:SetText(Util.GetLocaleString("AdvancedToolsTooltip"), nil, nil, nil, nil, 1);
	end
end

function CustomAction.SetCursor(Action)
	if (Action == 'configuremode') then
		UILib.StartDraggingIcon(Const.ImagesDir.."ConfigurePickup.tga", 23, 23, "customaction", Action);
	elseif (Action == 'createbarmode') then
		UILib.StartDraggingIcon(Const.ImagesDir.."CreateBarPickup.tga", 23, 23, "customaction", Action);
	elseif (Action == 'destroybarmode') then
		UILib.StartDraggingIcon(Const.ImagesDir.."DestroyBarPickup.tga", 23, 23, "customaction", Action);
	elseif (Action == 'advancedtoolsmode') then
		UILib.StartDraggingIcon(Const.ImagesDir.."AdvancedToolsPickup.tga", 23, 23, "customaction", Action);
	end
	
end