--[[
    Author: Alternator (Massiner of Nathrezim)
    Copyright 2010
	
	Notes:
]]

local UILib = BFUILib;
local Util = BFUtil;

local DragIcon = CreateFrame("FRAME", "ssasm", BFIconDragOverlay);
DragIcon:SetPoint("TOPLEFT", UIParent, "TOPLEFT");
DragIcon:SetFrameStrata("FULLSCREEN_DIALOG");
DragIcon.Texture = DragIcon:CreateTexture();
DragIcon.Texture:SetPoint("TOPLEFT", DragIcon, "TOPLEFT");
DragIcon.Texture:SetPoint("BOTTOMRIGHT", DragIcon, "BOTTOMRIGHT");

function UILib.StartDraggingIcon(Icon, Width, Height, Command, Data, Subvalue)
	BFIconDragOverlay:Show();
	SetCursor("");
	DragIcon.Texture:SetTexture(Icon);
	DragIcon:SetSize(Width, Height);
	DragIcon.CustomCommand = Command;
	DragIcon.CustomData = Data;
	DragIcon.CustomSubvalue = Subvalue;
	PlaySoundFile("Sound\\Interface\\Uspelliconpickup.Wav");
	Util.CursorAction = true;
	Util.RefreshGridStatus();
	DragIcon:RegisterEvent("CURSOR_UPDATE");
end

function UILib.StopDraggingIcon()
	if (DragIcon.CustomCommand) then
		DragIcon:UnregisterEvent("CURSOR_UPDATE");
		DragIcon:UnregisterEvent("CURSOR_UPDATE");
		DragIcon.CustomCommand = nil;
		DragIcon.CustomData = nil;
		DragIcon.CustomSubvalue = nil;
		PlaySoundFile("Sound\\Interface\\Uspellicondrop.Wav");
		SetCursor(nil);
		DragIcon:UnregisterEvent("CURSOR_UPDATE");	
		Util.CursorAction = false;
		Util.RefreshGridStatus();
		BFIconDragOverlay:Hide()
	end
end

function UILib.GetDragInfo()
	return DragIcon.CustomCommand, DragIcon.CustomData, DragIcon.CustomSubvalue;
end

function DragIcon:OnEvent(Event)
	UILib.StopDraggingIcon();
end

function DragIcon:OnUpdate()
	local Left, Top = GetCursorPosition();
	local Scale = UIParent:GetEffectiveScale();

	if (self.Left ~= Left or self.Top ~= Top) then	
		self.Left = Left;
		self.Top = Top;
		self:ClearAllPoints();
		self:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", Left / Scale, Top / Scale);
	end
end


DragIcon:SetScript("OnEvent", DragIcon.OnEvent);
DragIcon:SetScript("OnUpdate", DragIcon.OnUpdate);
